﻿using UnityEngine;
using System.Collections;

public class Palloscripti : MonoBehaviour {
	public GameObject AudioDisappear;
	public GameObject AudioCollide;
	public GameObject AudioFail;
	public GameObject AudioBumper;
	public GameObject AudioBallFloor;

	public bool is_player = false;
    public Transform particleExplosion;

    public Transform[] cartoonExplosions;

    public Texture2D[] ballTextures;
    public Color[] colors = { Color.cyan, Color.blue, Color.green, Color.magenta, Color.red, Color.yellow };

    public float xRange, zRange, startY, playerX, playerY, playerZ;

	public static int ballCount = 0;

    public float ballAirTime;
    public float ballAirTimeRand;

    float simulatePhysicsTime;

    public float bumperForce;
    public float bumperExploRadius;


// Use this for initialization
	void Start () {
//        renderer.material.color = colors[Random.Range(0,colors.Length)];
        arvoTextuuri(this);
        //NewBall(this);
        Palloscripti.ballCount++;
        if (is_player) ballAirTime = 10000000;
	}

    public void arvoTextuuri(Palloscripti pallo)
    {
        pallo.simulatePhysicsTime = Time.time+pallo.ballAirTime+Random.Range(0,ballAirTimeRand);

        pallo.renderer.material.mainTexture = pallo.ballTextures[Random.Range(0, pallo.ballTextures.Length)];

    }

    public void NewBall(Palloscripti pallo)
    {
        arvoTextuuri(pallo);
        pallo.rigidbody.Sleep();
        pallo.transform.rotation = Quaternion.identity;
        pallo.transform.position = Vector3.zero;
        pallo.rigidbody.velocity = Vector3.zero;
        pallo.rigidbody.angularVelocity = Vector3.zero;
        if (!pallo.is_player) pallo.transform.Translate(Random.Range(-xRange, xRange), startY, Random.Range(-zRange, zRange));
        else pallo.transform.Translate(playerX, playerY, playerZ);
    }
	
	// Update is called once per frame
	void Update () {
	}

    void FixedUpdate()
    {
        if (Time.time < simulatePhysicsTime)
        {
            rigidbody.Sleep();
//            Debug.Log("t:" + Time.time + ": s:" + simulatePhysicsTime);
        }
        else rigidbody.WakeUp();

    }

    void OnCollisionEnter(Collision collision)

    {
        Collider that_coll = collision.contacts[0].otherCollider;
		Collider this_coll = collision.contacts[0].thisCollider;

        if (that_coll.tag == "Seina")
        {
            this_coll.rigidbody.AddExplosionForce(bumperForce, transform.position * 1.2f, bumperExploRadius);
			Instantiate(AudioBumper);
        }

		if (that_coll.tag == "Plane") {
			Instantiate(AudioBallFloor);
		}

        if (this_coll.GetInstanceID() > that_coll.GetInstanceID()) {

			if (this_coll.tag == "Pallo" && that_coll.tag == "Pallo")
            {

				Palloscripti this_ball = (Palloscripti)this_coll.GetComponent<Palloscripti>();
				Palloscripti that_ball = (Palloscripti)that_coll.GetComponent<Palloscripti>();

                Transform partikkeli = (Transform)Instantiate(particleExplosion, this_ball.transform.position, Quaternion.identity);
                partikkeli.particleSystem.startColor = this_ball.renderer.material.color;

                partikkeli = (Transform)Instantiate(particleExplosion, that_ball.transform.position, Quaternion.identity);
                partikkeli.particleSystem.startColor = that_ball.renderer.material.color;


				if (this_ball.renderer.material.mainTexture == that_ball.renderer.material.mainTexture) {
					Scorescripti s = (Scorescripti)GameObject.Find("Score").GetComponent<Scorescripti>();

					if (this_ball.is_player || that_ball.is_player) {
						s.is_final_score = true;
						Musicscripti m = (Musicscripti)GameObject.Find("Music").GetComponent<Musicscripti>();
						m.setTargetVolume(0.0f);

						Instantiate(AudioFail);
						Instantiate(AudioDisappear);
					} else {
						s.score += 2;

						Instantiate(AudioCollide);
						Instantiate(AudioDisappear);
					}

                    Transform partikkeli2 = (Transform)Instantiate(cartoonExplosions[Random.Range(0, cartoonExplosions.Length)], this_ball.transform.position, Quaternion.identity);
                    partikkeli2.transform.Translate(Vector3.up * 0.3f);
//					Destroy(this_ball.gameObject);
//					Destroy(that_ball.gameObject);
                    NewBall(this_ball);
                    NewBall(that_ball);

					Palloscripti.ballCount -= 2;

				} else {
					Instantiate(AudioCollide);

					Texture temp_c = this_ball.renderer.material.mainTexture;
                    this_ball.renderer.material.mainTexture= that_ball.renderer.material.mainTexture;
                    that_ball.renderer.material.mainTexture= temp_c;
				}
            }
        }
    }
}
